'use strict';

var decorators = require('@sapphire/decorators');
var framework = require('@sapphire/framework');
var builders = require('@discordjs/builders');
var functions_cjs = require('./functions.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var RegisterSubCommand = /* @__PURE__ */ __name((parentCommandName, slashSubcommand) => {
  return decorators.createClassDecorator(
    (target) => decorators.createProxy(target, {
      construct: (ctor, [context, baseOptions]) => {
        const slashSubcommandParsed = typeof slashSubcommand === "function" ? slashSubcommand(new builders.SlashCommandSubcommandBuilder(), framework.container) : slashSubcommand;
        const ctr = new ctor(context, {
          ...baseOptions,
          name: framework.container.client.options.subcommandsAdvanced?.nameCommandsAutogenerated === true ? `${parentCommandName}/${slashSubcommandParsed.name}` : baseOptions.name
        });
        return functions_cjs.analizeSubCommandParsed(ctr, parentCommandName, slashSubcommandParsed);
      }
    })
  );
}, "RegisterSubCommand");
var RegisterSubCommandGroup = /* @__PURE__ */ __name((parentCommandName, groupName, slashSubcommand) => {
  return decorators.createClassDecorator(
    (target) => decorators.createProxy(target, {
      construct: (ctor, [context, baseOptions]) => {
        const slashSubcommandParsed = typeof slashSubcommand === "function" ? slashSubcommand(new builders.SlashCommandSubcommandBuilder(), framework.container) : slashSubcommand;
        const ctr = new ctor(context, {
          ...baseOptions,
          name: framework.container.client.options.subcommandsAdvanced?.nameCommandsAutogenerated === true ? `${parentCommandName}/${groupName}/${slashSubcommandParsed.name}` : baseOptions.name
        });
        return functions_cjs.analizeSubcommandGroupParsed(ctr, parentCommandName, groupName, slashSubcommandParsed);
      }
    })
  );
}, "RegisterSubCommandGroup");

exports.RegisterSubCommand = RegisterSubCommand;
exports.RegisterSubCommandGroup = RegisterSubCommandGroup;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=decorators.cjs.map