import { UserError } from '@sapphire/framework';
import { IMessageSubcommandPayload, SubcommandMappingMethod, IChatInputSubcommandPayload, ChatInputSubcommandDeniedPayload, MessageSubcommandDeniedPayload } from '@sapphire/plugin-subcommands';
import { SubcommandsAdvancedEvents, PluginSubcommandOptions } from './lib/utils/types.mjs';

declare module '@sapphire/plugin-subcommands' {
    interface MessageSubcommandDeniedPayload extends IMessageSubcommandPayload {
        subcommand: SubcommandMappingMethod;
    }
    interface ChatInputSubcommandDeniedPayload extends IChatInputSubcommandPayload {
        subcommand: SubcommandMappingMethod;
    }
}
declare module 'discord.js' {
    interface ClientEvents {
        [SubcommandsAdvancedEvents.ChatInputSubcommandDenied]: [error: UserError, payload: ChatInputSubcommandDeniedPayload];
        [SubcommandsAdvancedEvents.MessageSubcommandDenied]: [error: UserError, payload: MessageSubcommandDeniedPayload];
    }
    interface ClientOptions {
        subcommandsAdvanced?: PluginSubcommandOptions;
    }
}
